#pragma once

#include <exception>
#include <string>

class Bureaucrat
{
	private:
		const std::string _name;
		int _grade;

	public:
		Bureaucrat();
		~Bureaucrat();
		Bureaucrat(const Bureaucrat& src);
		Bureaucrat(const std::string& name, int grade);

		Bureaucrat& operator=(const Bureaucrat& src);

		const std::string& getName() const;
		int getGrade() const;
		void setGrade(int new_grade);

		void increment();
		void decrement();

		class GradeTooHighException: public std::exception
		{
			public:
				const char* what() const throw();
		};

		class GradeTooLowException: public std::exception
		{
			public:
				const char* what() const throw();
		};

};

std::ostream& operator<<(std::ostream& stream, Bureaucrat &src);
